//+------------------------------------------------------------------+
//|                                                         OsMA.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Silver
#property  indicator_width1  2
#property  indicator_level1  0.0
#property  indicator_level2  0.0006
#property  indicator_level3 -0.0006
#property  indicator_level4  0.0001
#property  indicator_level5 -0.0001
//---- indicator parameters
extern int FastEMA=50;
extern int SlowEMA=233;
extern int SignalSMA=9;
extern int LevelHigh=6;   //  
extern int LevelLow =-6;  //  
extern int Leveloh =0;  //  
extern int Use_Sound = 1;  // . .  = "0"
//---- indicator buffers
double     OsmaBuffer[];
double     MacdBuffer[];
double     SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexDrawBegin(0,SignalSMA);
   SetIndexStyle(1,DRAW_LINE);
   IndicatorDigits(Digits+2);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,OsmaBuffer);
   SetIndexBuffer(1,MacdBuffer);
   SetIndexBuffer(2,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("OsMA("+FastEMA+","+SlowEMA+"),Alert= "+LevelHigh+"/"+LevelLow);
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
      MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd additional buffer
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
//---- main loop
   for(i=0; i<limit; i++)
      OsmaBuffer[i]=MacdBuffer[i]-SignalBuffer[i];
//---- signal line counted in the 2-nd buffer
   if(OsmaBuffer[1]<LevelHigh*Point && OsmaBuffer[0]>=LevelHigh*Point && Use_Sound==1)
     {PlaySound("alert.wav");Sleep(400);PlaySound("alert.wav");  }
   if(OsmaBuffer[1]<Leveloh*Point && OsmaBuffer[0]>=Leveloh*Point && Use_Sound==1)
     {PlaySound("alert.wav");Sleep(400);PlaySound("alert.wav");  }
   if(OsmaBuffer[1]>LevelLow*Point  && OsmaBuffer[0]<=LevelLow*Point  && Use_Sound==1)
     {PlaySound("alert.wav");Sleep(400);PlaySound("alert.wav");Sleep(400);PlaySound("alert.wav");  }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

